import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'menus' },
})
export class Menus extends BaseModel {
  @prop({ required: false, index: false, zh: '菜单名称' })
  name: string;
  @prop({ required: false, index: false, zh: '路由名称', remark: '英文' })
  route_name: string;
  @prop({ required: false, index: false, zh: '国际化编码' })
  i18n_code: string;
  @prop({ required: false, index: true, zh: '父级菜单' })
  parent_id: string;
  @prop({ required: false, index: false, zh: '显示顺序' })
  order_num: number;
  @prop({ required: false, index: false, zh: '路由地址' })
  path: string;
  @prop({ required: false, index: false, zh: '组件地址' })
  component: string;
  @prop({ required: false, index: true, zh: '菜单类型', remark: '0:目录;1:菜单;2:子页面' })
  type: string;
  @prop({ required: false, index: false, zh: '图标' })
  icon: string;
  @prop({ required: false, index: false, zh: '功能列表', remark: '不在功能列表中的功能不能使用' })
  config: Array<any>;
  @prop({ required: false, index: true, zh: '是否为默认菜单', default: '1', remark: '默认:0,非默认:1; 默认不能删除' })
  is_default: string;
  @prop({ required: false, index: false, zh: '备注' })
  remark: string;
  @prop({ required: false, index: true, zh: '是否启用', default: '0' })
  is_use: string;
}
