import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_config {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: 'logo' })
  'logo': Array<any> = undefined;
  @ApiProperty({ description: '早餐时间' })
  'b_time': Array<any> = undefined;
  @ApiProperty({ description: '午餐时间' })
  'l_time': Array<any> = undefined;
  @ApiProperty({ description: '晚餐时间' })
  'd_time': Array<any> = undefined;
}


export class QDTO_config extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
}


export class QVO_config extends FVO_config {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}


export class CDTO_config {
  @ApiProperty({ description: 'logo' })
@Rule(RuleType['array']().empty(''))
  'logo': Array<any> = undefined;
  @ApiProperty({ description: '早餐时间' })
@Rule(RuleType['array']().empty(''))
  'b_time': Array<any> = undefined;
  @ApiProperty({ description: '午餐时间' })
@Rule(RuleType['array']().empty(''))
  'l_time': Array<any> = undefined;
  @ApiProperty({ description: '晚餐时间' })
@Rule(RuleType['array']().empty(''))
  'd_time': Array<any> = undefined;
}


export class CVO_config extends FVO_config {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}


export class UDTO_config extends CDTO_config {
    @ApiProperty({ description: '数据id' })
    @Rule(RuleType['string']().empty(''))
    _id: string = undefined;
}


export class UVAO_config extends FVO_config {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}